"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _default = function _default(editorViewRef, storageKey) {
  var backup = (0, _react.useCallback)(function () {
    if (storageKey) {
      var _editorViewRef$curren;

      var value = ((_editorViewRef$curren = editorViewRef.current) === null || _editorViewRef$curren === void 0 ? void 0 : _editorViewRef$curren.state.doc.toString()) || '';

      if (value.length > 0 && !/^(\s|\r?\n)*$/.test(value)) {
        localStorage.setItem(storageKey, value);
      } else {
        localStorage.removeItem(storageKey);
      }
    }
  }, []);
  (0, _react.useEffect)(function () {
    if (storageKey) {
      var backupValue = localStorage.getItem(storageKey);

      if (backupValue) {
        var _editorViewRef$curren2, _editorViewRef$curren3;

        var currentValue = (_editorViewRef$curren2 = editorViewRef.current) === null || _editorViewRef$curren2 === void 0 ? void 0 : _editorViewRef$curren2.state.doc.toString();
        (_editorViewRef$curren3 = editorViewRef.current) === null || _editorViewRef$curren3 === void 0 ? void 0 : _editorViewRef$curren3.dispatch({
          changes: {
            from: 0,
            to: currentValue === null || currentValue === void 0 ? void 0 : currentValue.length,
            insert: backupValue
          }
        });
      }

      window.addEventListener('beforeunload', backup);
      return function () {
        window.removeEventListener('beforeunload', backup);
        backup();
      };
    }
  }, [backup]);
};

exports.default = _default;